<?php
require_once('../../config.php');
require_once('scan_assignment.php');
require_once('detection_tools.php');

global $DB;

reconstruct_file('182', '181', '/tmp');

function reconstruct_file($student_id, $other_student_id, $dir) {
    $code_file = $dir.'/'.$student_id;

    $dom = new DOMDocument();
    $dom->preserveWhiteSpace = false;
    $content = file_get_contents($code_file);
    @$dom->loadHTML('<pre>'.$content.'</pre>');

    $pre = $dom->childNodes->item(1)->firstChild->firstChild; // root->html->body->pre

    $line_no = 1;
    $current_file = '';
    $portion_list = array();
    $node = $pre->firstChild;
    while ($node!=null) {
        if ($node->nodeType==XML_TEXT_NODE) {
            $line_no += substr_count($node->nodeValue, "\n");  // count the line
        } else if ($node->tagName=='h3') {
            $current_file = $node->nodeValue;
            $line_no = 1;
        } else if ($node->tagName=='span' && $node->getAttribute('type')=='begin') {
            $sid = explode(',', $node->getAttribute('sid'));
            $key = array_search($other_student_id, $sid);
            if ($key!==false) { // matching portion
                $anchors = explode(',', $node->getAttribute('anchor'));
                $anchor = $anchors[$key];
                $colors = explode(',',  $node->getAttribute('color'));
                $color = $colors[$key];

                $font = $dom->createElement('font');
                $font->setAttribute('color', $color);
                $font->setAttribute('class', 'sim_'.$anchor);
                $font = $node->parentNode->insertBefore($font, $node);
                $sibling = $node->nextSibling;
                $start_line = $line_no;
                while (!end_span_node($sibling, $other_student_id)) {
                    if ($sibling->nodeType==XML_TEXT_NODE) {
                        $line_no += substr_count($sibling->nodeValue, "\n");
                    }
                    $next_sibling = $sibling->nextSibling;
                    $font->appendChild($sibling);
                    $sibling = $next_sibling;
                }
                if (count($sid)==1) { // remove the mark if this portion has in common with only one student
                    $node->parentNode->removeChild($node);
                    $sibling->parentNode->removeChild($sibling);
                } else { // if not, move the marks within the font
                    $font->insertBefore($node, $font->firstChild);
                    $font->appendChild($sibling);
                }
                $node = $font;

                $portion_list[$anchor] = array('file'=>$current_file, 'line'=>"$start_line-$line_no", 'color'=>$color);
            }
        }
        $node = $node->nextSibling;
    }
    return array('list'=>$portion_list, 'content'=>$dom->saveHTML());
}

function end_span_node($node, $student_id) {
    if ($node->nodeType==XML_ELEMENT_NODE &&
           $node->tagName=='span' &&
           $node->getAttribute('type')=='end') {
        $end_sid = explode(',', $node->getAttribute('sid'));
        return in_array($student_id, $end_sid);
    } else {
        return false;
    }
}
